/* Copyright 2013-2021 Rene Widera, Benjamin Worpitz, Alexander Debus
 *
 * This file is part of PMacc.
 *
 * PMacc is free software: you can redistribute it and/or modify
 * it under the terms of either the GNU General Public License or
 * the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * PMacc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License and the GNU Lesser General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License
 * and the GNU Lesser General Public License along with PMacc.
 * If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "pmacc/types.hpp"

#include "pmacc/algorithms/math/defines/abs.hpp"
#include "pmacc/algorithms/math/defines/exp.hpp"
#include "pmacc/algorithms/math/defines/trigo.hpp"
#include "pmacc/algorithms/math/defines/cross.hpp"
#include "pmacc/algorithms/math/defines/dot.hpp"
#include "pmacc/algorithms/math/defines/comparison.hpp"
#include "pmacc/algorithms/math/defines/floatingPoint.hpp"
#include "pmacc/algorithms/math/defines/modf.hpp"
#include "pmacc/algorithms/math/defines/bessel.hpp"
#include "pmacc/algorithms/math/defines/pi.hpp"

#include "pmacc/algorithms/math/floatMath/abs.tpp"
#include "pmacc/algorithms/math/floatMath/exp.tpp"
#include "pmacc/algorithms/math/floatMath/trigo.tpp"
#include "pmacc/algorithms/math/floatMath/comparison.tpp"
#include "pmacc/algorithms/math/floatMath/floatingPoint.tpp"
#include "pmacc/algorithms/math/floatMath/modf.tpp"
#include "pmacc/algorithms/math/floatMath/bessel.tpp"

#include "pmacc/algorithms/math/doubleMath/abs.tpp"
#include "pmacc/algorithms/math/doubleMath/exp.tpp"
#include "pmacc/algorithms/math/doubleMath/trigo.tpp"
#include "pmacc/algorithms/math/doubleMath/comparison.tpp"
#include "pmacc/algorithms/math/doubleMath/floatingPoint.tpp"
#include "pmacc/algorithms/math/doubleMath/modf.tpp"
#include "pmacc/algorithms/math/doubleMath/bessel.tpp"
